
/*
-------------------------------------------------------------------

      Convert Los Alamos FPGA code to BNL downlodable FPGA code

-------------------------------------------------------------------
*/

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#ifdef DOS
#include "..\commands.h"
#include "..\nodes.h"
#else
#include "commands.h"
#include "nodes.h"
#endif
main(int argc, char *argv[])
{
/*   int found,byt=0,i,j; */
 int i;
 FILE    *fp1, *fout1, *fout2, *ftmp;
 char x;
 unsigned long int hibyte;
 unsigned long int nbytes=0, nbytes1=0, nbytes2=0;
 unsigned int count;
 unsigned int icmd;
 int iarg;

 if (argc == 5)
 {
  if (atoi(argv[4]) == 1)
  {   
   icmd = DCIM_FPGA;
  }
  else
  {
   if (atoi(argv[4]) == 2)
   {   
    icmd = MCM_FPGA;
   }
   else
   {
      printf("invalid 3rd option %s: 1=dcim/2=mcm\n",argv[4]);
      exit(1);
   }
  }
  fp1 = fopen(argv[1],"r");
  fout1 = fopen(argv[2],"w");
  fout2 = fopen(argv[3],"w");
  
  if (fp1 == NULL)
  {
   printf("\ncan't open input file  %s\n",argv[1]);
   exit(1);
  }
  if (fout1 == NULL)
  {
   printf("\ncan't open 1st output file  %s\n",argv[2]);
   exit(1);
  }
  if (fout2 == NULL)
  {
   printf("\ncan't open 2nd output file  %s\n",argv[3]);
   exit(1);
  }

 }
 else
 {
  printf("\n Los Alamos --> BNL FPGA code converter");
  printf(" \n Convert FPGA hex string into arcnet downloadable hex file\n");
  printf("\n\nformat:  \nconvert <INPUT FILENAME> <OUTPUT1 FILENAME>  <OUTPUT2 FILENAME> <OPTION>\n");
  printf("\n<OPTION> = 1 --> dcim fpga");
  printf("\n<OPTION> = 2 --> mcm fpga\n");
  exit(1);
 }


 printf("working please wait\n");
 i=0;
 nbytes1=0;
 for(count=0x0;count<0x6fff;count++)  /* 30 kB limit */
 {
  x=(char) fgetc(fp1);
  if (x == '\n' || x == EOF)  break;
  fputc(x,fout1);
  x=(char) fgetc(fp1);
  if (x == '\n' || x == EOF)  break;
  fputc(x,fout1);
  fputc(' ',fout1);
  i++;
  nbytes1++;
  if (i == 16)
  {
   fputc('\n',fout1);
   i=0;
  }
 }
 printf("nbytes in %s: hex: %x \n",argv[2],nbytes1);
 printf("nbytes in %s: dec: %u \n",argv[2],nbytes1);
 i=0;
 nbytes2=0;
 for(count=0x0;count<0x6fff;count++)  /* 30 kB limit */
 {
  x=fgetc(fp1);
  if (x == '\n' || x == EOF)  break;
  fputc(x,fout2);
  x=fgetc(fp1);
  if (x == '\n' || x == EOF)  break;
  fputc(x,fout2);
  fputc(' ',fout2);
  i++;
  nbytes2++;
  if (i == 16)
  {
   fputc('\n',fout2);
   i=0;
  }
 }
 /* fcloseall(); */
 fclose(fout2);
 fclose(fp1);
 fclose(fout1);
 printf("nbytes in %s: hex: %x\n",argv[3],nbytes2);
 printf("nbytes in %s: dec: %u\n",argv[3],nbytes2);
 printf("total nbytes: hex: %x\n",nbytes=nbytes1+nbytes2);
 printf("total nbytes: dec: %u\n",nbytes=nbytes1+nbytes2);

        /* include arcnet headers in first file */
 ftmp = fopen("tmp.tmp","w");
 fout1 = fopen(argv[2],"r");
 nbytes1 += 8;  /* arcnet header size */
 fprintf(ftmp,"%x %x %x %x\n",0x0,icmd,FIRST_PACKET,GROUP); 
 /* 
    thats weird, if  left like the following the last number is zero
    so we split it up
   fprintf(ftmp,"%x %x %x %x\n",0x0,0x0,hibyte>>8,nbytes1 & 0x00FF); 
*/
 fprintf(ftmp,"%x %x %x ",0x0,0x0,nbytes1>>8);
 fprintf(ftmp,"%x\n",nbytes1 & 0x00FF); 
 while((x=fgetc(fout1))!=EOF) fputc(x,ftmp);
 /* fcloseall(); */
 fclose(ftmp);
 remove(argv[2]);
 rename("tmp.tmp",argv[2]);

        /* include arcnet headers in second file */
 ftmp = fopen("tmp.tmp","w");
 fout2 = fopen(argv[3],"r");
 nbytes2 += 8;  /* arcnet header size */
 fprintf(ftmp,"%x %x %x %x\n",0x0,icmd,SECOND_PACKET,GROUP); 
/* 
  see above...
 fprintf(ftmp,"%x %x %x %x\n",0x0,0x0,nbytes2>>8,nbytes2 & 0x00FF); 
*/
 fprintf(ftmp,"%x %x %x ",0x0,0x0,nbytes2>>8);
 fprintf(ftmp,"%x\n",nbytes2 & 0x00FF); 
 while((x=fgetc(fout2))!=EOF) fputc(x,ftmp);
 /* fcloseall(); */
 fclose(ftmp);
 remove(argv[3]);
 rename("tmp.tmp",argv[3]);
 printf("length+head %s: hex %x\n",argv[2],nbytes1);
 printf("length+head %s: dec %u\n",argv[2],nbytes1);
 printf("length+head %s: hex %x\n",argv[3],nbytes2);
 printf("length+head %s: dec %u\n",argv[3],nbytes2);
 printf("DONE....\n");
 exit(0);
}
