echo "Start script to put MVD in raw (2 ADCs per channel) configuration."
echo "You should do a complete feed of the MVD BEFORE YOU START THIS SCRIPT"
echo "If you have not done so, stop and do it NOW."
echo " "

#  The following command sets up the MCM serial strings for raw mode -- done with soft links.
#  This does not load the serial strings.
cd /export/software/oncs/online_configuration/Arcnet/mvd/hex
ls -l setup_serial_run_rawmode
echo "MCM serial strings reset for raw mode"

#  reload DCIMs with code for raw mode (actually only one serial bit is changed)
which $ARCNET_BIN/arcnet_client 
ls -l $ARCNET_DATA/mvd/acf/mvd_dcim_fpga_raw.acf
echo "DCIM FPGAs reloaded -- setup for raw mode"
echo " "

#  reload MCM FPGA code version for raw mode -- this must come before loading serial strings
ls -l $ARCNET_DATA/mvd/acf/mvd_mcm_fpga_raw.acf
echo "MCM fpga code setup for raw mode"
echo " "

# download MCM serial strings and read them back
ls -l $ARCNET_DATA/mvd/acf/mvd_mcm_serial_run.acf
echo "MCM serial strings downloaded"

ls -l $ARCNET_DATA/mvd/acf/mvd_mcm_read_serial.acf
echo "MCM serial strings read back. Note that we have not tried to work"
echo "around the various known readback errors -- so you should expect"
echo "some readback errors, but they should not all fail"
echo " "

# The following is probably useless, because this gets processed
# when run control is started.
which process_pcf_file.sh 
ls -l $ONLINE_CONFIGURATION/rc/hw/mvd.pcf
echo "processed pcf file with ALTERNATE flag"
echo "-----------------------------------"

echo "Do not FEED the MVD until you are ready to switch back to normal"
echo "running. This script has reloaded some different information in"
echo "the MCMs and DCIMs. A re-feed will overwrite these modifications"
echo "When you are ready to proceed, start runcontrol."
echo "Before you hit download in runcontrol, type (in another window):"
echo "process_pcf_file.sh -DALTERNATE $ONLINE_CONFIGURATION/rc/hw/mvd.pcf"
echo "Then do a download. There may be a way to do this inside run control"
echo "by setting an ALTERNATE or CALIBRATION flag."
